<template>
  <div>
    <div v-if="!current" class="no-item">Методология не выбрана</div>
    <ob-modal
      ref="modal-error"
      :title="'Ошибка на сервере'"
      :isShowControls="true"
      :isReadOnly="true"
    />
    <ob-modal
      ref="modal-success"
      :title="'Данные сохранены'"
      :isShowControls="true"
      :isReadOnly="true"
    />
    <ob-modal
      ref="modal-delete"
      :isError="true"
      okText="Да"
      :title="'Удалить методику?'"
      :isShowControls="true"
      @submit="deleteMethodology"
    />
    <ob-modal
      ref="modal-param-delete"
      :isError="true"
      okText="Да"
      :title="'Удалить параметр?'"
      :isShowControls="true"
      @submit="deleteParameter"
    />
    <ob-form
      v-if="current"
      class="settings-form"
      :isSubmitDisabled="!formValid"
      :isCancelDisabled="!formValid"
      :isOnlySubmit="!activated"
      @submit="save"
      @cancel="resetFormToCurrent"
      :cancelText="'Исходные'"
      :formData="currentMethodologyFormData"
      ref="form"
    >
      <template slot="title">
        <strong>Настройка методики рейтингования</strong>
      </template>
      <div>
        <div class="edit-method">
          <ob-input
            class="edit-method__input"
            :label="'Наименование'"
            :placeholder="'Введите'"
            v-model="currentMethodologyFormData.name"
            type="text"
            :disabled="!activated"
          />
          <ob-checkbox
            :class="{'edit-method__check': true, 'active': active}"
            :label="'Статус'"
            @change="changeStatus()"
            v-model="isStatusActive"
            :disabled="!activated"
          />
        </div>
        <ob-selector
          class="edit-method"
          :items="roles"
          :placeholder="'Выберите'"
          :label="'Роль'"
          @input="changeRole()"
          v-model="currentMethodologyFormData.participantType"
          :disabled="!activated"
        />
        <ob-selector
          class="edit-method"
          :items="activities"
          :placeholder="'Выберите'"
          :disabled="(currentMethodologyFormData.participantType !== 'CARRIER') || !activated"
          :label="'Направление деятельности'"
          v-model="currentMethodologyFormData.participantActivityUuid"
        />
        <ob-textarea
          :placeholder="'Выберите'"
          :label="'Краткое описание'"
          rows="10"
          class="edit-method"
          v-model="currentMethodologyFormData.description"
          :disabled="!activated"
        />
      </div>
    </ob-form>
    <ob-button
      v-if="current"
      :label="'Удалить'"
      danger
      style="margin: 18px 0;"
      @click="$refs['modal-delete'].open()"
      :disabled="!activated"
    />
    <div v-if="current" style="border-top: 1px solid #D1D2D6;">
      <ob-table
        :columns="parameters"
        :items="paramsData"
        group-by="name"
        :addButtonText="'Добавить параметр'"
        :functionalPanel="true"
        :showAddButton="activated"
        @add="openParamPopup()"
        :footer-disabled="true"
      />
      <div v-if="activated && parametersForChange.length && parameterForChangeResetFlag" class="change-param">
        <ObSelector
          :placeholder="'Выберите'"
          :label="'Выбор параметра методики для изменения или удаления'"
          :items="parametersForChange"
          v-model="chosenParameterForChangeUuid"
        />
        <div class="change-param-buttons">
          <ob-button
            class="change-param-buttons_change"
            :label="'Изменить параметр'"
            style="margin: 10px 0;"
            :disabled="!chosenParameterForChangeUuid"
            @click="openParamPopup(true)"
          />
          <ob-button
            :label="'Удалить параметр'"
            style="margin: 10px 0;"
            danger
            :disabled="!chosenParameterForChangeUuid"
            @click="openDeleteParameterPopup"
          />
        </div>
        <div v-if="isDeleteParameterError" class="text-red">Ошибка. Не удалось удалить параметр.</div>
      </div>
      <div class="table">
        <p class="table__header">{{quality}}</p>
        <ob-input
          class="table__item"
          :label="'Удовлетворительно'"
          :placeholder="'Введите значение'"
          type="number"
          v-model="currentThresholdFormData.satisfactory"
          :disabled="!activated"
        />
        <ob-input
          class="table__item"
          :label="'Хорошо'"
          :placeholder="'Введите значение'"
          type="number"
          v-model="currentThresholdFormData.good"
          :disabled="!activated"
        />
        <ob-input
          class="table__item"
          :label="'Отлично'"
          :placeholder="'Введите значение'"
          type="number"
          v-model="currentThresholdFormData.excellent"
          :disabled="!activated"
        />
      </div>
      <div class="table">
        <p class="table__header">{{fresh}}</p>
        <ob-input
          class="table__item"
          :label="'Совсем недавно'"
          :placeholder="'Введите значение'"
          type="number"
          v-model="currentFreshnessFormData.shortGap"
          :disabled="!activated"
        />
        <ob-input
          class="table__item"
          :label="'Не так давно'"
          :value="middle"
          type="text"
          disabled
        />
        <ob-input
          class="table__item"
          :label="'Совсем давно'"
          :placeholder="'Введите значение'"
          type="number"
          v-model="currentFreshnessFormData.longGap"
          :disabled="!activated"
        />
        <ob-input
          class="table__item"
          :label="'Совсем недавно (вес)'"
          :placeholder="'Введите значение'"
          type="number"
          v-model="currentFreshnessFormData.shortGapScore"
          :disabled="!activated"
        />
        <ob-input
            class="table__item"
            :label="'Не так давно (вес)'"
            :value="(1-(+currentFreshnessFormData.shortGapScore)-(+currentFreshnessFormData.longGapScore)).toFixed(1)"
            type="number"
            disabled
        />
        <ob-input
          class="table__item"
          :label="'Совсем давно (вес)'"
          :placeholder="'Введите значение'"
          type="number"
          v-model="currentFreshnessFormData.longGapScore"
          :disabled="!activated"
        />
      </div>
    </div>
    <parameter-standart
      ref="constructorPopup"
      v-if="current"
      :parameterForChange="chosenParameterForChange"
    />
  </div>
</template>

<script>
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
import ObSelector from "common-components/src/obComponents/obSelect";
import ObCheckbox from "common-components/src/obComponents/obCheckbox";
import ObTextarea from "common-components/src/obComponents/obTextarea";
import ObButton from "common-components/src/obComponents/obButton";
import ObModal from 'common-components/src/obComponents/obModal';
import ObTable from "common-components/src/obComponents/obTable";
import { UPDATE_METHODOLOGY, DELETE_METHODOLOGY } from "../../../store/modules/methodology";
import { UPDATE_THRESHOLD } from "../../../store/modules/threshold";
import { UPDATE_FRESHNESS } from "../../../store/modules/freshness";
import { GET_METHODOLOGIES } from "../../../store/modules/methodologies";
import { DELETE_PARAMETER } from '../../../store/modules/parameter';
import parameterStandart from "./parameterStandart";

export default {
  data() {
    return {
      roles: [
        {
          uuid: "CLIENT",
          title: "Клиент"
        },
        {
          uuid: "CARRIER",
          title: "Перевозчик"
        }
      ],
      statusValue: "",
      makeActiveMethodology: "",
      statusColor: undefined,
      isStatusActive: undefined,
      active: false,
      currentMethodologyFormData: {
        uuid: "",
        name: "",
        participantType: "",
        participantActivityUuid: "",
        description: "",
        status: ""
      },
      currentThresholdFormData: {
        satisfactory: undefined,
        good: undefined,
        excellent: undefined
      },
      currentFreshnessFormData: {
        shortGap: undefined,
        longGap: undefined,
        shortGapScore: undefined,
        longGapScore: undefined
      },
      quality: "Пороги рейтинга для отображения качественной оценки",
      fresh: "Критерии свежести данных",
      parameters: [
        {
          title: "",
          key: "period"
        },
        {
          title: "",
          key: "weight"
        },
        {
          title: "",
          key: "unit"
        }
      ],
      chosenParameterForChangeUuid: null,
      parameterForChangeResetFlag: true,
      isDeleteParameterError: false,
    };
  },
  components: {
    ObForm,
    ObInput,
    ObSelector,
    ObCheckbox,
    ObTextarea,
    ObButton,
    ObTable,
    ObModal,
    parameterStandart
  },
  methods: {
    save() {
      const payload = {
        uuid: this.currentMethodologyFormData.uuid,
        name: this.currentMethodologyFormData.name,
        description: this.currentMethodologyFormData.description,
        participantType: this.currentMethodologyFormData.participantType,
        participantActivityUuid: this.currentMethodologyFormData
          .participantActivityUuid,
        status: this.statusValue,
        makeActiveMethodologyUuid: this.makeActiveMethodology
      };
      const payloadThreshold = {
        satisfactory: this.currentThresholdFormData.satisfactory,
        good: this.currentThresholdFormData.good,
        excellent: this.currentThresholdFormData.excellent
      };
      const payloadFreshness = {
        shortGap: this.currentFreshnessFormData.shortGap,
        longGap: this.currentFreshnessFormData.longGap,
        shortGapScore: this.currentFreshnessFormData.shortGapScore,
        longGapScore: this.currentFreshnessFormData.longGapScore
      };
      try {
        this.$store.dispatch(UPDATE_METHODOLOGY, payload);
        this.$store.dispatch(UPDATE_THRESHOLD, {
          uuid: this.current.uuid,
          payloadThreshold
        });
        this.$store.dispatch(UPDATE_FRESHNESS, {
          uuid: this.current.uuid,
          payloadFreshness
        });
        this.$refs['modal-success'].open();
        this.$store.dispatch(GET_METHODOLOGIES);
        if (this.parametersForChange.length === 1) {
          this.parameterForChangeResetFlag = false;
          setTimeout(() => {
            this.parameterForChangeResetFlag = true;
          }, 500)
        }
      } catch (ex) {
        this.$refs['modal-error'].open();
        console.log(ex);
      }
    },
    deleteMethodology() {
      try {
        this.$store.dispatch(
          DELETE_METHODOLOGY,
          this.currentMethodologyFormData.uuid
        );
        this.$store.dispatch(GET_METHODOLOGIES);
        this.$refs['modal-delete'].close();
      } catch (ex) {
        this.$refs['modal-error'].open();
        console.log(ex);
      }
    },
    changeStatus() {
      if (this.statusValue === "ACTIVE") {
        this.statusValue = "NOT_ACTIVE";
        this.isStatusActive = false;
        this.active = false;
        this.makeActiveMethodology = this.gridData.find(
          item =>
            item.status === "NOT_ACTIVE" && item.uuid !== this.current.uuid
        );
      } else {
        this.statusValue = "ACTIVE";
        this.isStatusActive = true;
        this.makeActiveMethodology = "";
        this.active = true;
      }
    },
    changeRole() {
      console.log('changed role')
      console.log(this.currentMethodologyFormData.participantActivityUuid)
      this.currentMethodologyFormData.participantActivityUuid = '';
    },
    updateForm(current) {
      this.chosenParameterForChangeUuid = null
      this.isDeleteParameterError = false
      this.currentMethodologyFormData.uuid = current.uuid;
      this.currentMethodologyFormData.name = current.name;
      this.currentMethodologyFormData.description = current.description;
      this.currentMethodologyFormData.participantType = current.participantType;
      this.currentMethodologyFormData.participantActivityUuid =
        current.participantActivityUuid;
      if (this.$refs.form) this.$refs.form.resetForm();
    },
    updateThreshold(currentThreshold) {
      this.currentThresholdFormData.satisfactory =
        currentThreshold.satisfactory;
      this.currentThresholdFormData.good = currentThreshold.good;
      this.currentThresholdFormData.excellent = currentThreshold.excellent;
    },
    updateFreshness(currentFreshness) {
      this.currentFreshnessFormData.shortGap = currentFreshness.shortGap || "";
      this.currentFreshnessFormData.longGap = currentFreshness.longGap || "";
      this.currentFreshnessFormData.shortGapScore =
        currentFreshness.shortGapScore || "";
      this.currentFreshnessFormData.longGapScore =
        currentFreshness.longGapScore || "";
    },
    resetFormToCurrent() {
      this.updateForm(this.current);
      if (this.parametersForChange.length === 1) {
        this.parameterForChangeResetFlag = false;
        setTimeout(() => {
          this.parameterForChangeResetFlag = true;
        }, 500)
      }
      // this.$refs["form"].resetForm();
    },
    openParamPopup(isEdit = false) {
      if (!isEdit) {
        this.chosenParameterForChangeUuid = null
      }
      this.isDeleteParameterError = false
      this.$refs["constructorPopup"].open();
    },
    openDeleteParameterPopup() {
      this.$refs["modal-param-delete"].open();
    },
    async deleteParameter() {
      this.isDeleteParameterError = false
      const res = await this.$store.dispatch(DELETE_PARAMETER, { methodology_uuid: this.current.uuid, parameter_uuid: this.chosenParameterForChangeUuid })
      this.$refs["modal-param-delete"].close();
      if (res.error) {
        this.isDeleteParameterError = true
      }
    }
  },
  computed: {
    paramsData() {
      const data = this.$store.getters.getParams;
      const preparedData = [];
      for (let i = 0; i < data.length; i++) {
          const item = data[i];
          if (item.parameter.type === "SIMPLE") {
              for (let j = 0; j < item.value.ranges.length; j++) {
                  const points = item.value.ranges[j];
                  const from = () => {
                    if (!points.from) {
                      return '0'
                    }
                    return points.from
                  }
                  const to = () => {
                    if (points.to === null) {
                      return '∞'
                    }
                    return points.to
                  }
                  preparedData.push({
                      period: from() + '-' +  to(),
                      weight: points.point,
                      name: item.parameter.name,
                      unit: item.parameter.unitOfMeasurement === "CONVENTIONAL_UNIT" ? "Условная единица" :
                        item.parameter.unitOfMeasurement === "MINUTE" ? "Минута" : 
                        item.parameter.unitOfMeasurement === "HOUR" ? "Час" : 
                        item.parameter.unitOfMeasurement === "DAY" ? "День" : 
                        item.parameter.unitOfMeasurement === "PIECES" ? "Штука" : 
                        item.parameter.unitOfMeasurement === "PERCENT" ? "Процент" : 
                        item.parameter.unitOfMeasurement === "NUMBER_OF_TIMES" ? "Количество раз" : ""
                  });
              }
          } else if (item.parameter.type === "HARD") {
              for (let j = 0; j < item.value.pointRanges.length; j++) {
                  const points = item.value.pointRanges[j];
                  const from = () => {
                    if (!points.from) {
                      return '0'
                    }
                    return points.from
                  }
                  const to = () => {
                    if (points.to === null) {
                      return '∞'
                    }
                    return points.to
                  }
                  preparedData.push({
                      period: from() + '-' +  to(),
                      weight: points.point,
                      name: item.parameter.name,
                      unit: item.parameter.unitOfMeasurement === "CONVENTIONAL_UNIT" ? "Условная единица" : 
                        item.parameter.unitOfMeasurement === "MINUTE" ? "Минута" : 
                        item.parameter.unitOfMeasurement === "HOUR" ? "Час" : 
                        item.parameter.unitOfMeasurement === "DAY" ? "День" : 
                        item.parameter.unitOfMeasurement === "PIECES" ? "Штука" : 
                        item.parameter.unitOfMeasurement === "PERCENT" ? "Процент" : 
                        item.parameter.unitOfMeasurement === "NUMBER_OF_TIMES" ? "Количество раз" : ""
                  });
              }
          }
          else if (item.parameter.type === "BINARY") {
            // for (let j = 0; j < item.value.length; j++) {
              const points = item.value;
              preparedData.push({
                period: 'Да',
                weight: points.pointIfTrue,
                name: item.parameter.name,
                unit: item.parameter.unitOfMeasurement === "CONVENTIONAL_UNIT" ? "Условная единица" :
                        item.parameter.unitOfMeasurement === "MINUTE" ? "Минута" :
                        item.parameter.unitOfMeasurement === "HOUR" ? "Час" :
                        item.parameter.unitOfMeasurement === "DAY" ? "День" :
                        item.parameter.unitOfMeasurement === "PIECES" ? "Штука" :
                        item.parameter.unitOfMeasurement === "PERCENT" ? "Процент" :
                        item.parameter.unitOfMeasurement === "NUMBER_OF_TIMES" ? "Количество раз" : ""
              });
              preparedData.push({
                period: 'Нет',
                weight: points.pointIfFalse,
                name: item.parameter.name,
                unit: item.parameter.unitOfMeasurement === "CONVENTIONAL_UNIT" ? "Условная единица" : 
                        item.parameter.unitOfMeasurement === "MINUTE" ? "Минута" : 
                        item.parameter.unitOfMeasurement === "HOUR" ? "Час" : 
                        item.parameter.unitOfMeasurement === "DAY" ? "День" : 
                        item.parameter.unitOfMeasurement === "PIECES" ? "Штука" : 
                        item.parameter.unitOfMeasurement === "PERCENT" ? "Процент" : 
                        item.parameter.unitOfMeasurement === "NUMBER_OF_TIMES" ? "Количество раз" : ""
              });
          }
          else if (item.parameter.type === "EXCLUDE") {
            // for (let j = 0; j < item.value.length; j++) {
              const points = item.value;
              if (points.excludeValue === true) {
                preparedData.push({
                  period: "Исключение",
                  weight: "Да",
                  name: item.parameter.name,
                  unit: item.parameter.unitOfMeasurement === "CONVENTIONAL_UNIT" ? "Условная единица" : 
                        item.parameter.unitOfMeasurement === "MINUTE" ? "Минута" : 
                        item.parameter.unitOfMeasurement === "HOUR" ? "Час" : 
                        item.parameter.unitOfMeasurement === "DAY" ? "День" : 
                        item.parameter.unitOfMeasurement === "PIECES" ? "Штука" : 
                        item.parameter.unitOfMeasurement === "PERCENT" ? "Процент" : 
                        item.parameter.unitOfMeasurement === "NUMBER_OF_TIMES" ? "Количество раз" : ""
                });
              } else {
                preparedData.push({
                  period: "Исключение",
                  weight: "Нет",
                  name: item.parameter.name,
                  unit: item.parameter.unitOfMeasurement === "CONVENTIONAL_UNIT" ? "Условная единица" : 
                        item.parameter.unitOfMeasurement === "MINUTE" ? "Минута" : 
                        item.parameter.unitOfMeasurement === "HOUR" ? "Час" : 
                        item.parameter.unitOfMeasurement === "DAY" ? "День" : 
                        item.parameter.unitOfMeasurement === "PIECES" ? "Штука" : 
                        item.parameter.unitOfMeasurement === "PERCENT" ? "Процент" : 
                        item.parameter.unitOfMeasurement === "NUMBER_OF_TIMES" ? "Количество раз" : ""
                });
              }
          }
          else {
            //
          }
      }
      return preparedData;
    },
    current() {
      return this.$store.getters.getCurrentMethodology;
    },
    activities() {
      return this.$store.getters.getActivities;
    },
    gridData() {
      return this.$store.getters.getMethodologies;
    },
    currentThreshold() {
      return this.$store.getters.getCurrentThreshold;
    },
    currentFreshness() {
      return this.$store.getters.getCurrentFreshness;
    },
    formValid() {
      if (
        this.currentMethodologyFormData.name === this.current.name &&
        this.currentMethodologyFormData.description ===
          this.current.description &&
        this.currentMethodologyFormData.participantType ===
          this.current.participantType &&
        this.currentMethodologyFormData.participantActivityUuid ===
          this.current.participantActivityUuid &&
        this.statusValue === this.current.status &&
        this.currentThresholdFormData.satisfactory ===
          this.currentThreshold.satisfactory &&
        this.currentThresholdFormData.good === this.currentThreshold.good &&
        this.currentThresholdFormData.excellent ===
          this.currentThreshold.excellent &&
        this.currentFreshnessFormData.shortGap ===
          this.currentFreshness.shortGap &&
        this.currentFreshnessFormData.longGap ===
          this.currentFreshness.longGap &&
        this.currentFreshnessFormData.shortGapScore ===
          this.currentFreshness.shortGapScore &&
        this.currentFreshnessFormData.longGapScore ===
          this.currentFreshness.longGapScore
      )
        return false;
      else return true;
    },
    activated() {
      if (this.current.startActivityDt !== null) return false;
      else return true;
    },
    middle() {
      return `${+this.currentFreshnessFormData.shortGap+1} - ${+this.currentFreshnessFormData.longGap-1}`;
    },
    parametersForChange() {
      const params = this.$store.getters.getParams
      const preparedData = []
      params.map((item) => {
        preparedData.push({
          title: item.parameter.name,
          uuid: item.uuid,
        })
      })
      return preparedData
    },
    chosenParameterForChange() {
      const index = this.$store.getters.getParams.findIndex((item) => item.uuid === this.chosenParameterForChangeUuid)
      if (index >= 0) {
        return this.$store.getters.getParams[index]
      }
      return false
    },
  },
  watch: {
    current() {
      this.statusValue = this.current.status;
      this.isStatusActive = this.current.status === "ACTIVE";
      this.current.status === "ACTIVE"
        ? (this.active = true)
        : (this.active = false);
      if (this.current.uuid !== undefined) {
        this.updateForm(this.current);
      } else {
        throw new Error();
      }
    },
    currentThreshold() {
      if (
        (this.currentThreshold && this.currentThreshold.satisfactory) !==
          undefined &&
        (this.currentThreshold && this.currentThreshold.good) !== undefined &&
        (this.currentThreshold && this.currentThreshold.excellent) !== undefined
      ) {
        this.updateThreshold(this.currentThreshold);
      } else {
        if (
          this.currentThreshold &&
          this.currentThreshold.satisfactory !== undefined
        ) {
          this.currentThresholdFormData.satisfactory = this.currentThreshold.satisfactory;
        } else this.currentThresholdFormData.satisfactory = 0;
        if (this.currentThreshold && this.currentThreshold.good !== undefined) {
          this.currentThresholdFormData.good = this.currentThreshold.good;
        } else this.currentThresholdFormData.good = 0;
        if (
          this.currentThreshold &&
          this.currentThreshold.excellent !== undefined
        ) {
          this.currentThresholdFormData.excellent = this.currentThreshold.excellent;
        } else this.currentThresholdFormData.excellent = 0;
      }
    },
    currentFreshness() {
      if (
        (this.currentFreshness && this.currentFreshness.shortGap) !==
          undefined &&
        (this.currentFreshness && this.currentFreshness.longGap) !==
          undefined &&
        (this.currentFreshness && this.currentFreshness.shortGapScore) !==
          undefined &&
        (this.currentFreshness && this.currentFreshness.longGapScore) !==
          undefined
      ) {
        this.updateFreshness(this.currentFreshness);
      } else {
        if (
          this.currentFreshness &&
          this.currentFreshness.shortGap !== undefined
        ) {
          this.currentFreshnessFormData.shortGap = this.currentFreshness.shortGap;
        } else this.currentFreshnessFormData.shortGap = 0;
        if (
          this.currentFreshness &&
          this.currentFreshness.longGap !== undefined
        ) {
          this.currentFreshnessFormData.longGap = this.currentFreshness.longGap;
        } else this.currentFreshnessFormData.longGap = 0;
        if (
          this.currentFreshness &&
          this.currentFreshness.shortGapScore !== undefined
        ) {
          this.currentFreshnessFormData.shortGapScore = this.currentFreshness.shortGapScore;
        } else this.currentFreshnessFormData.shortGapScore = 0;
        if (
          this.currentFreshness &&
          this.currentFreshness.longGapScore !== undefined
        ) {
          this.currentFreshnessFormData.longGapScore = this.currentFreshness.longGapScore;
        } else this.currentFreshnessFormData.longGapScore = 0;
      }
    }
  }
};
</script>

<style lang="scss" scoped>
.no-item {
  color: #9c9c9c;
  padding: 40px 20px;
  text-align: center;
  position: sticky;
  top: 20px;
  text-transform: uppercase;
  font-weight: 700;
  font-size: 24px;
}
.edit-method {
  display: flex;
  // padding: 10px 0;
  margin: 10px 0;
  &__input {
    width: 80%;
    margin: 0;
  }
  &__check {
    align-self: center;
    margin: auto;
    //noinspection CssInvalidPseudoSelector
    &::v-deep {
      .label-text {
        color: red !important;
      }
    }
  }
}
.active {
  //noinspection CssInvalidPseudoSelector
  &::v-deep {
    .label-text {
      color: green !important;
    }
  }
}
.table {
  padding: 10px 0;
  display: flex;
  flex-wrap: wrap;
  width: 100%;
  &__item {
    width: 33.33%;
    padding: 10px 0;
  }
  &__header {
    width: 100%;
  }
}

.change-param {
  margin: 20px 0;
}
.change-param-buttons {
  display: flex;
}
.change-param-buttons_change {
  margin-right: 10px !important;
}
.text-red {
  color: red;
}
.settings-form {
  border-bottom: 2px dotted #99b7e9;
  padding-bottom: 20px;
}
</style>


